<script setup>
import { onMounted, ref } from "vue";

// initialize props
const props = defineProps({
  task: Object,
});

// reactive variable for new value of task name
const newValue = ref("");

// Set the value from task prop
onMounted(() => {
  newValue.value = props.task?.value;
});
</script>

<template>
  <div class="modal flex flex-col justify-between">
    <div class="flex justify-between">
      <h2>Update Task</h2>
      <!-- Emit event on Main component to close the modal -->
      <div
        @click="$emit('close')"
        class="close-modal flex justify-center items-center"
      >
        X
      </div>
    </div>

    <!-- Input for new value of task -->
    <div class="input-container">
      <span>Task Name</span>
      <!-- Emit onUpdate event on Main component -->
      <input
        @keyup.enter="$emit('onUpdate', props.task, newValue)"
        v-model="newValue"
      />
    </div>

    <div class="btns flex">
      <button
        class="btn-success"
        @click="$emit('onUpdate', props.task, newValue)"
      >
        Save
      </button>
      <button @click="$emit('close')" class="btn-neutral">Cancel</button>
    </div>
  </div>
</template>

<style scoped>
.modal {
  background: #ffffff;
  height: 250px;
  max-width: 400px;
  width: 100%;
  position: fixed;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  padding: 1rem;
  z-index: 4;
  border-radius: 10px;
}
input {
  padding: 10px;
  width: 100%;
  font-size: 24px;
}
.input-container span {
  color: grey;
}

.btns {
  justify-content: flex-end;
  gap: 1rem;
}
</style>
